library ieee;
use ieee.std_logic_1164.all;
use work.TypePack.all;

entity AddSVE is
  port (Clk, Reset : in std_logic;
        Add, Sig, SigA, Var : out Nat4);
end AddSVE;

architecture AddSVA of AddSVE is
  signal AddS, SigS : Nat4 := 0;
begin
-- pragma synthesis_off
  AddS <= AddS +1 after 2 ns;
-- pragma synthesis_on  
  process (Clk, Reset)
    variable VarV : Nat4 := 0;
  begin
    if Reset = '1' then
      SigS <= 0; SigA <= 0;
      VarV := 0; Var <= 0;
    elsif rising_edge(clk) then
      SigS <= SigS + 1;
      SigA <= SigS;
      VarV := VarV + 1;
      Var <= VarV;
    end if;
  end process;
  Add <= AddS;
  Sig <= SigS;
end architecture AddSVA;
-------------------------------------------------------------------
-- pragma synthesis_off
library ieee;
use ieee.std_logic_1164.all;
use work.UtilPack.all;
use work.TypePack.all;

entity AddSVTbE is
end AddSVTbE;

architecture AddSVTbA of AddSVTbE is
  component AddSVE is
    port (Clk, Reset : in std_logic;
          Add, Sig, SigA, Var : out Nat4);
  end component;
  signal ClkS, ResetS : std_logic := '0';
  signal AddS, SigS, SigAS, VarS : Nat4 := 0;
begin
  AddSVI : AddSVE 
    port map (Clk => ClkS, Reset => ResetS, Add => AddS, 
              Sig => SigS, SigA => SigAS, Var => VarS);
  ClkS <= not ClkS after 1 ns;
  ResetS <= '1', 
            '0' after 0.5 ns; 
  StopSim(10 ns);
end architecture AddSVTbA;
-- pragma synthesis_on