--------------------------------------------------------- Testbench
-- pragma synthesis_off 
                            
library ieee;
use ieee.std_logic_1164.all;
use work.UtilPack.all;

entity BusTbE is
  generic (ClockT : time := 1 ns);                                           
end BusTbE;                                                

architecture BusTbA of BusTbE is                         
  component CBusTE                        -- Transceiver concurrent
    port (En : in std_logic; 
          Bi : in std_logic_vector(3 downto 0); 
          Bo : out std_logic_vector(3 downto 0);        
          B  : inout std_logic_vector(3 downto 0));                                               
  end component;
  signal CEnS : std_logic := '0'; 
  signal CBiS, CBoS : std_logic_vector(3 downto 0);
  
  component SBusTE                        -- Transceiver sequential                      
    port (En: in std_logic; 
          Bi: in std_logic_vector(3 downto 0); 
          Bo: out std_logic_vector(3 downto 0);
          B : inout std_logic_vector(3 downto 0));                                              
  end component;  
  signal SEnS : std_logic := '0'; 
  signal SBiS, SBoS : std_logic_vector(3 downto 0); 
                                                             -- bus 
  signal BusS : std_logic_vector(3 downto 0);                                                              
begin                                                        
  CBusTI: CBusTE                           
    port map(En => CEnS, Bi => CBiS, Bo => CBoS, B => BusS);      

  CBiS <= "0000" after 1*ClockT,
          "0001" after 3*ClockT;         
 
  CEnS <= '0' after 0*ClockT,                                
          '1' after 2*ClockT,
          '0' after 4*ClockT,                                
          '0' after 6*ClockT,
          '0' after 8*ClockT,                                
          '1' after 10*ClockT;
                             
  SBusTI: SBusTE                           
    port map(En => SEnS, Bi => SBiS, Bo => SBoS, B => BusS);     
    
  SBiS <= "0000" after 1*ClockT,
          "0010" after 7*ClockT;         
 
  SEnS <= '0' after 0*ClockT,                                
          '0' after 2*ClockT,
          '0' after 4*ClockT,                                
          '1' after 6*ClockT,
          '0' after 8*ClockT,                                
          '1' after 10*ClockT;

  StopSim(12 ns);
        
end BusTbA;  
-- pragma synthesis_on     