library ieee;
use ieee.std_logic_1164.all;

entity DffE is
  port (Reset, Preset, Enable, Clk, D: in std_logic;
        Qf, Qr, Qrp, Qrpe : out std_logic);
end DffE;

architecture DffA of DffE is
begin

-- pragma synthesis_off
  DffFaulty : process(Reset, Clk)
  begin
    if Reset='1' then
      Qf <= '0';
    end if;
    if rising_edge(Clk) then
      Qf <= D;
    end if;
  end process;
-- pragma synthesis_on  

  DffReset : process(Reset, Clk)
  begin
    if Reset='1' then
      Qr <= '0';
    else 
		if rising_edge(Clk) then
      Qr <= D;
		end if;
	 end if;
  end process;

  DffResetPreset : process(Reset, Preset, Clk)
  begin
	 if Reset='1' then
      Qrp <= '0';
    else 
		if Preset='1' then
			Qrp <= '1';
		else
			if rising_edge(Clk) then
			Qrp <= D;
			end if;
		end if;
	 end if;
  end process;

  DffResetPresetEnable : process(Reset, Preset, Enable, Clk)
  begin
	 if Enable='1' then
		 if Reset='1' then
			Qrp <= '0';
		 else 
			if Preset='1' then
				Qrp <= '1';
			else
				if rising_edge(Clk) then
				Qrp <= D;
				end if;
			end if;
		 end if;
	 end if;
  end process;

end architecture DffA;

--------------------------------------------------------------------
-- pragma synthesis_off 

library ieee;
use ieee.std_logic_1164.all;
use work.UtilPack.all;

entity DffTbE is
  generic (ClkT : time := 1 ns);
end DffTbE;

architecture DffTbA of DffTbE is
  signal ResetS, PreSetS, EnableS, ClkS, DS, QfS, QrS, QrpS, QrpeS : std_logic := '0';
  component DffE is
    port (Reset, Preset, Enable, Clk, D: in std_logic;
        Qf, Qr, Qrp, Qrpe : out std_logic);
  end component;

begin

  DffI:DffE
    port map(ResetS, PreSetS, EnableS, ClkS, DS, QfS, QrS, QrpS, QrpeS);
      
  process(clkS)
  begin
    ClkS <= not ClkS after ClkT;
  end process;
  
  ResetS <= '1' after 0*ClkT,
            '0' after 4*ClkT,
            '1' after 6*ClkT,
            '0' after 8*ClkT;
 

  PreSetS <= '0' after 0*ClkT,
             '1' after 12*ClkT,
             '0' after 14*ClkT;
          
  EnableS <= '1' after 0*ClkT,
             '0' after 16*ClkT,
             '1' after 18*ClkT;          
             
  DS <= '0' after 0*ClkT,
        '1' after 2*ClkT,
        '0' after 11*ClkT,
        '0' after 14*ClkT,
        '1' after 16*ClkT;        
			
  StopSim(20 ns);
  
end DffTbA;

-- pragma synthesis_on