library ieee;
use ieee.std_logic_1164.all;

entity DffNE is
  port (Reset, Clk, D: in std_logic;
        Q2, Qn2, Q1, Qn1 : out std_logic);
end DffNE;

architecture DffNA of DffNE is
signal Q1s: std_logic;
begin

--  Dff2 : process(Reset, Clk, D)
--  begin
--    if Reset='1' then
--      Q2 <= '0';
--      Qn2 <= '1';
--    elsif rising_edge(clk) then
--      Q2 <= D;
--      Qn2 <= not D;
--    end if;
--  end process;
	Q1 <= Q1s;
	Qn1 <= not Q1s;
	
  Dff1 : process(Reset, Clk, D)
  begin
	if Reset='1' then
      Q1s <= '0';
      --Qn1 <= '1';
    elsif rising_edge(clk) then
		Q1s <= D;
		-- Q1 <= Q1s;
      -- Qn1 <= not Q1s;
    end if;
  end process;

end architecture DffNA;

--------------------------------------------------------------------
-- pragma synthesis_off 

library ieee;
use ieee.std_logic_1164.all;
use work.UtilPack.all;

entity DffNTbE is
  generic (ClkT : time := 1 ns);
end DffNTbE;

architecture DffNTbA of DffNTbE is
  signal ResetS, ClkS, DS, Q2S, Qn2S, Q1S, Qn1S : std_logic := '0';
  component DffNE is
    port (Reset, Clk, D: in std_logic;
        Q2, Qn2, Q1, Qn1 : out std_logic);
  end component;

begin

  DffNI:DffNE
    port map(ResetS, ClkS, DS, Q2S, Qn2S, Q1S, Qn1S);
      
  process(clkS)
  begin
    ClkS <= not ClkS after ClkT;
  end process;
  
  ResetS <= '1' after 0*ClkT,
            '0' after 2*ClkT;
 
  DS <= '1' after 0*ClkT,
        '0' after 4*ClkT,
        '1' after 6*ClkT; 

--  process
--  begin
--  wait for 3.5 ns; 
--  assert Q2s='0' report "Q2s ist richtig!";
--  assert Qn2s='0' report "Qn2s ist falsch!";
--  end process;
			
  StopSim(10 ns);
  
end DffNTbA;

-- pragma synthesis_on