---------------------------------------------------------------- Ff
library ieee;
use ieee.std_logic_1164.all;

entity FfE is
  port (Clk, Reset : in std_logic;
        D : in std_logic_vector(3 downto 0);
        Q : out std_logic_vector(3 downto 0));
end;
  
architecture FfA of FfE is
begin
  process(Clk, Reset)
  begin
    if rising_edge(Clk) then
      if Reset = '1' then
        Q <= (others => '0');
      else
        Q <= D;
      end if; 
    end if;      
  end process;
end;

------------------------------------------------------ Testbench Ff
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use work.UtilPack.all;

entity FfTbE is
  generic (ClkT : time := 1 ns);
end FfTbE;

architecture FfTbA of FfTbE is

  component FfE
    port (Clk, Reset : in std_logic;
          D : in std_logic_vector(3 downto 0);
          Q : out std_logic_vector(3 downto 0));
  end component;

  signal ClkS, ResetS : std_logic := '1';
  signal D1S, Q1S, D2S, Q2S : std_logic_vector(3 downto 0) := "0000";

begin  

  Ff1 : FfE
    port map (
      Clk => ClkS,
      Reset => ResetS,
      D => D1S,
      Q => Q1S);

  Ff2 : FfE
    port map (
      Clk => ClkS,
      Reset => ResetS,
      D => D2S,
      Q => Q2S);

  ResetS <= '1' after 0*ClkT,
            '0' after 0.5 * ClkT;

  ClkS <= not ClkS after ClkT;
  
  D1S <= D1S + 1 after 2*ClkT;
  
  process (ClkS)
  begin
    if rising_edge(ClkS) then
      D2S <= D2S +1;
    end if;
  end process;

  StopSim(20 ns);
  
end FfTbA;