library ieee;
use ieee.std_logic_1164.all;

entity IfCaseE is
  port (I0, I1, I2, I3 : in std_logic;
        S0, S1 : in std_logic;
        OIf, OCase1, OCase2 : out std_logic);
end IfCaseE;

architecture IfCaseA of IfCaseE is
  signal Sv1, Sv2 : std_logic_vector (1 downto 0);
begin

  ProcIf : process (S0, S1, I0, I1, I2, I3)
  begin
    if S1 = '0' then
      OIf <= I0;
    elsif S0 = '0' then
      OIf <= I2;
    else 
      OIf <= I3;
    end if;
  end process ProcIf;

  Sv1 <= S1&S0;
  ProcCase1 : process (Sv1, I0, I1, I2, I3)
  begin
    case Sv1 is
      when "00" => OCase1 <= I0;
      when "01" => OCase1 <= I1;
      when "10" => OCase1 <= I2;
      when "11" => OCase1 <= I3;
      when others => OCase1 <= I0; 
    end case;      
  end process ProcCase1;
  
  ProcCase2 : process (S0, S1, I0, I1, I2, I3)
  begin
    Sv2 <= S1&S0;
    case Sv2 is
      when "00" => OCase2 <= I0;
      when "01" => OCase2 <= I1;
      when "10" => OCase2 <= I2;
      when "11" => OCase2 <= I3;
      when others => OCase2 <= I0; 
    end case;      
  end process ProcCase2;
    
end IfCaseA; 
 
--  pragma synthesis_off
library ieee;
use ieee.std_logic_1164.all;
use work.UtilPack.all;

entity IfCaseTbE is
end IfCaseTbE;

architecture IfCaseTbA of IfCaseTbE is
  component IfCaseE is
    port (I0, I1, I2, I3 : in std_logic;
          S0, S1 : in std_logic;
          OIf, OCase1, OCase2 : out std_logic);
  end component;  
  signal I0S, I1S, I2S, I3S, S0S, S1S, OIfS, OCase1S, OCase2S : std_logic := '0';
  
begin
  IfCaseI : IfCaseE 
    port map (I0S, I1S, I2S, I3S, S0S, S1S, OIfS, OCase1S, OCase2S);

  I0S <= '0' after 0 ns,  
         '1' after 1 ns,
         '0' after 3 ns,
         '1' after 11 ns,
         '0' after 12 ns;     
  I1S <= '0' after 0 ns,  
         '1' after 3 ns,
         '0' after 5 ns,
         '1' after 10 ns,
         '0' after 11 ns;  
  I2S <= '0' after 0 ns,  
         '1' after 5 ns,
         '0' after 7 ns;
  I3S <= '0' after 0 ns,  
         '1' after 7 ns,
         '0' after 9 ns;           
  S0S <= '0' after 0 ns,  
         '1' after 2 ns,
         '0' after 4 ns,  
         '1' after 6 ns,
         '0' after 8 ns,
         '1' after 10 ns;
  S1S <= '0' after 0 ns,
         '1' after 4 ns,
         '0' after 8 ns; 

  StopSim(12 ns);
    
end architecture IfCaseTbA;

--  pragma synthesis_on