library ieee;
use ieee.std_logic_1164.all;

entity LatchE is
  port (D, Clk: in std_logic;
        Q: out std_logic);
end LatchE;

architecture LatchA of LatchE is
signal save : std_logic := '0' ;
begin
	-- save <= D when Clk = '1' else save;

	process (Clk, D)
		begin
			if Clk = '1' then
				save <= D;
			else 
				save <=  not D;
			end if;
	end process;
  Q <= save;
end LatchA;

--------------------------------------------------------------------
-- pragma synthesis_off 

library ieee;
use ieee.std_logic_1164.all;
use work.UtilPack.all;

entity LatchTbE is
  generic (ClkT : time := 1 ns);
end LatchTbE;

architecture LatchTbA of LatchTbE is
  signal ClkS, DS, QS : std_logic := '0';
  component LatchE is
    port (D, Clk: in std_logic;
          Q: out std_logic);
  end component;
  
begin
  
  LatchI:LatchE
    port map(DS, ClkS, QS);

  process(DS)
  begin
    
    DS <= not DS after ClkT;
  
  end process;
             
  ClkS <= '0' after 0 ns,
          '1' after 2 ns,
          '0' after 6 ns,
          '1' after 7 ns,
          '0' after 9 ns;
         
  StopSim(20 ns);

end LatchTbA;

-- pragma synthesis_on